<template>
  <BaseMap
    :style="mapStyle"
    :center="centroidLatLng"
    :bounds="bounds"
    :overlays-config="mapOverlays"
    :current-plot-id="plot.id"
  />
</template>

<script>
import * as L from 'leaflet'
import BaseMap from 'src/components/BaseMap'
import {
  getHoldingCampaignPlotsLayer,
  getHydrographyWaterCourseLayer,
  getProtectedSiteNatura2000Layer,
  getRegulationZoneNVZLayer,
  getHydrographySurfaceWaterLayer
} from 'src/services/map/layers/layer-configs'
import PlotConstraintMixin from 'src/pages/holding-campaign/plot/mixins/PlotConstraintMixin'

export default {
  name: 'PlotConstraintMap',
  components: {
    BaseMap
  },
  mixins: [
    PlotConstraintMixin
  ],
  props: {
    mapStyle: {
      type: String,
      default: ''
    },
    plot: {
      type: Object,
      required: true
    },
    constraint: {
      type: Object,
      required: true
    }
  },
  computed: {
    centroidLatLng () {
      if (this.plot && this.plot.centroid) {
        return [this.plot.centroid.coordinates[1], this.plot.centroid.coordinates[0]]
      } else {
        return null
      }
    },
    bounds () {
      const plotBboxCoords = this.plot?.bbox?.coordinates
      if (plotBboxCoords) {
        const bounds = L.polygon(plotBboxCoords).getBounds().pad(0.2)
        return [
          [bounds.getWest(), bounds.getNorth()],
          [bounds.getEast(), bounds.getSouth()]
        ]
      } else {
        return null
      }
    },
    mapOverlays () {
      const overlays = []

      const constraintOverlay = this.getConstraintOverlay()
      if (constraintOverlay) {
        // hide irrelevant features
        constraintOverlay.selectedFeatureId = this.constraintFeatureId(this.constraint)
        constraintOverlay.hideOtherFeatures = true
        overlays.push(constraintOverlay)
      }

      const constraintPlotLayer = {
        ...getHoldingCampaignPlotsLayer(true, { plotId: this.plot.id }),
        title: `${this.$gettext('Plot')} ${this.plot.name}`,
        currentPlotId: this.plot?.id
      }
      overlays.push(constraintPlotLayer)

      return overlays
    }
  },
  methods: {
    getConstraintOverlay () {
      switch (this.constraint.name) {
        case 'protected_site':
          return getProtectedSiteNatura2000Layer(true)
        case 'management_restriction_or_regulation_zone':
          return getRegulationZoneNVZLayer(true)
        case 'surface_water':
          return getHydrographySurfaceWaterLayer(true)
        case 'water_course':
          return getHydrographyWaterCourseLayer(true)
        default:
          console.error('No map overlay found for constraint ' + this.constraint.name)
          return null
      }
    }
  }
}
</script>
